//=============================================================================
//
// file :        PhysicalValue.h
//
// description : Include for the PhysicalValue class.
//
// project :	Physical Value device for defining user scaling
//
// $Author:  $
//
// $Revision:  $
//
// $Log:  $
//
// copyleft :    L.I.O.N.S
//				 Service de Chimie Molculaire
//				 Dpartement de Recherche sur l'Etat Condens, les Atomes et les Molcules
//				 Commissariat  L'Energie Atomique 
//               Centre d'Etudes de Saclay
//				 91191 Gif/Yvette Cedex
//               FRANCE
//				 http://www-drecam.cea.fr/scm/lions
//
//=============================================================================
//
//  		This file is generated by POGO
//	(Program Obviously used to Generate tango Object)
//
//         (c) - Software Engineering Group - ESRF
//=============================================================================
#ifndef _PHYSICALVALUE_H
#define _PHYSICALVALUE_H

#include <tango.h>
#include <stdio.h>
#include "mathexpr.h"
//using namespace Tango;

/**
 * @author	$Author:  $
 * @version	$Revision:  $
 */

 //	Add your own constants definitions here.
 //-----------------------------------------------


namespace PhysicalValue_ns
{

/**
 * Class Description:
 * A device to define the physical value to/from a Device Server Attribute<br>
 *	The final user can define his proper scaling, which can be diffrerent from hardware. <br>
 *	ex : angles or mm instead of step motor<br>
 *	In fact another mathematical expression parser for tango.<br>
 *	You need to specified : <br>
 *	- the attribute for reading and writing<br>
 *	- a mathematical variable name<br>
 *	- a mathematical expression for reading and writing the attribute<br>
 *	If attribute name is missing for reading/writing, or expression is wrong or missing, attribute is not readable or writable.<br>
 *	<br>Use the mathexpr library from <a href='http://www.eleves.ens.fr/home/ollivier/mathlib/mathexpr.html'>Yan OLLIVIER</a><br>
 *	can be download <a href='http://www.eleves.ens.fr/home/ollivier/mathlib/mathexpr.html'>here</a>
 *	
 */

/*
 *	Device States Description:
 *	Tango::ON :	Device is ready
 *	Tango::ALARM :	Problem
 *	Tango::FAULT :	Missing properties
 */


class PhysicalValue: public Tango::Device_3Impl
{
public :
	//	Add your own data members here
	//-----------------------------------------


	//	Here is the Start of the automatic code generation part
	//-------------------------------------------------------------	
/**
 *	@name attributes
 *	Attributs member data.
 */
//@{
		Tango::DevDouble	*attr_Value_read;
		Tango::DevDouble	attr_Value_write;
//@}

/**
 *	@name Device properties
 *	Device properties member data.
 */
//@{
/**
 *	Attribute Name for reading on remote device server
 */
	string	attributeName_read;
/**
 *	Attribute Name for writing on remote device server
 */
	string	attributeName_write;
/**
 *	
 */
	string	expression_read;
/**
 *	
 */
	string	expression_write;
/**
 *	
 */
	string	variable_name;
//@}

/**@name Constructors
 * Miscellaneous constructors */
//@{
/**
 * Constructs a newly allocated Command object.
 *
 *	@param cl	Class.
 *	@param s 	Device Name
 */
	PhysicalValue(Tango::DeviceClass *cl,string &s);
/**
 * Constructs a newly allocated Command object.
 *
 *	@param cl	Class.
 *	@param s 	Device Name
 */
	PhysicalValue(Tango::DeviceClass *cl,const char *s);
/**
 * Constructs a newly allocated Command object.
 *
 *	@param cl	Class.
 *	@param s 	Device name
 *	@param d	Device description.
 */
	PhysicalValue(Tango::DeviceClass *cl,const char *s,const char *d);
//@}

/**@name Destructor
 * Only one desctructor is defined for this class */
//@{
/**
 * The object desctructor.
 */	
	~PhysicalValue() {delete_device();};
/**
 *	will be called at device destruction or at init command.
 */
	void delete_device();
//@}

	
/**@name Miscellaneous methods */
//@{
/**
 *	Initialize the device
 */
	virtual void init_device();
/**
 *	Always executed method befor execution command method.
 */
	virtual void always_executed_hook();

//@}

/**
 * @name PhysicalValue methods prototypes
 */

//@{
/**
 *	Hardware acquisition for attributes.
 */
	virtual void read_attr_hardware(vector<long> &attr_list);
/**
 *	Extract real attribute values for Value acquisition result.
 */
	virtual void read_Value(Tango::Attribute &attr);
/**
 *	Write Value attribute values to hardware.
 */
	virtual void write_Value(Tango::WAttribute &attr);
/**
 *	Read/Write allowed for Value attribute.
 */
	virtual bool is_Value_allowed(Tango::AttReqType type);
/**
 * This command gets the device state (stored in its <i>device_state</i> data member) and returns it to the caller.
 *	@return	State Code
 *	@exception DevFailed
 */
	virtual Tango::DevState	dev_state();

/**
 *	Read the device properties from database
 */
	 void get_device_property();
//@}

	//	Here is the end of the automatic code generation part
	//-------------------------------------------------------------	



protected :	
	//	Add your own data members here
	//-----------------------------------------
	void write_on_DeviceProxy(Tango::DevDouble);
	Tango::DevDouble read_on_DeviceProxy();
	Tango::AttributeProxy* att_proxy_read;
	Tango::AttributeProxy* att_proxy_write;
	bool isWritable;
	bool isReadable;

	// mathematical expression parsing :
	double x_read;		// The number that the variable "x" will point to
	RVar *xvar_read;    //variable
	ROperation *op_read;//expression parsed
	double x_write;		// The number that the variable "x" will point to
	RVar *xvar_write;    //variable
	ROperation *op_write;//expression parsed

};

}	// namespace_ns

#endif	// _PHYSICALVALUE_H
