//=============================================================================
//
// file :         PhysicalValueClass.h
//
// description :  Include for the PhysicalValueClass root class.
//                This class is represents the singleton class for
//                the PhysicalValue device class.
//                It contains all properties and methods which the 
//                PhysicalValue requires only once e.g. the commands.
//			
// project :      TANGO Device Server
//
// $Author:  $
//
// $Revision:  $
//
// $Log:  $
//
// copyleft :     European Synchrotron Radiation Facility
//                BP 220, Grenoble 38043
//                FRANCE
//
//=============================================================================
//
//  		This file is generated by POGO
//	(Program Obviously used to Generate tango Object)
//
//         (c) - Software Engineering Group - ESRF
//=============================================================================

#ifndef _PHYSICALVALUECLASS_H
#define _PHYSICALVALUECLASS_H

#include <tango.h>
#include <PhysicalValue.h>


namespace PhysicalValue_ns
{
//=====================================
//	Define classes for attributes
//=====================================
class ValueAttrib: public Tango::Attr
{
public:
	ValueAttrib():Attr("Value", Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~ValueAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<PhysicalValue *>(dev))->read_Value(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
	{(static_cast<PhysicalValue *>(dev))->write_Value(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<PhysicalValue *>(dev))->is_Value_allowed(ty);}
};

//=========================================
//	Define classes for commands
//=========================================
//
// The PhysicalValueClass singleton definition
//

class PhysicalValueClass : public Tango::DeviceClass
{
public:

//	add your own data members here
//------------------------------------

public:
	Tango::DbData	cl_prop;
	Tango::DbData	cl_def_prop;
	Tango::DbData	dev_def_prop;

//	Method prototypes
	static PhysicalValueClass *init(const char *);
	static PhysicalValueClass *instance();
	~PhysicalValueClass();
	Tango::DbDatum	get_class_property(string &);
	Tango::DbDatum	get_default_device_property(string &);
	Tango::DbDatum	get_default_class_property(string &);
	
protected:
	PhysicalValueClass(string &);
	static PhysicalValueClass *_instance;
	void command_factory();
	void attribute_factory(vector<Tango::Attr *> &);
	void write_class_property();
	void set_default_property();

private:
	void device_factory(const Tango::DevVarStringArray *);
};


}	//	namespace PhysicalValue_ns

#endif // _PHYSICALVALUECLASS_H
